package sebekji1.cvi2.client;

import java.io.FileNotFoundException;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import sebekji1.cvi2.server.CsvReader;
import sebekji1.cvi2.server.DBExistException;
import sebekji1.cvi2.server.DBNotFoundException;
import sebekji1.cvi2.server.DuplicateKeyException;
import sebekji1.cvi2.server.KeyNotFoundException;
import sebekji1.cvi2.compute.*;

public class Client {
/*
	private static final String K_listDB = "listdb";
	private static final String K_createDB = "createdb";
	private static final String K_insert = "insert";
	private static final String K_update = "update";
	private static final String K_get = "get";
	private static final String K_getA = "geta";
	private static final String K_flush = "flush";
*/
	public static void main(String[] args) {
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}

		String host;
		int PORT;
		String conf_file;

		if (args.length != 3) {
			// <IP_adresa> <cislo_portu> <konf_soubor>

			host = "localhost"; //host = "127.0.0.1";
			PORT = 7777; 
			conf_file = "./data/conf.csv"; // konfig. soubor
			// System.exit(0);
		} else {
			host = args[0]; 
			PORT = Integer.valueOf(args[1]); 
			conf_file = args[2]; 
		}

		try {
			// vyhledani vzdaleneho objektu
			ServerInterface serveri;
			String name = "muj_server";
			Registry registry = LocateRegistry.getRegistry(host, PORT);

			 serveri = (ServerInterface) registry.lookup(name);
			//serveri = (ServerInterface) Naming.lookup("//"+host+":"+PORT+"/"+name);
			 CsvReader reader = null;
			 try{
				 reader = new CsvReader(conf_file, ';');
			 }catch (Exception e) {
					System.out.println("Cannot find a config file.");
					System.exit(1);
			 }
        //todo
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (Exception e) {
			System.err.println("Data exception: " + e.getMessage());
		}
	}
}
